summaryrefslogtreecommitdiffstats
path: root/test/name-test/run-test-systemserver.sh
diff options
context:
space:
mode:
authorColin Walters <walters@verbum.org>2008-12-04 14:27:21 -0500
committerColin Walters <walters@verbum.org>2008-12-05 11:39:36 -0500
commitc5526c18ad4dbf706e12ae46c5b8b26efa17e52c (patch)
tree537165307a4d8856cf426d10fddc3f63803d7522 /test/name-test/run-test-systemserver.sh
parent42d278a267359b5c93e839f033ecb306068557aa (diff)
Infrastructure for testing a "system like" bus in test suite
The tmp-session-like-system.conf bus configuration has a security policy intended to mirror that of the system bus. This allows testing policy rules.
Diffstat (limited to 'test/name-test/run-test-systemserver.sh')
-rwxr-xr-xtest/name-test/run-test-systemserver.sh41
1 files changed, 41 insertions, 0 deletions
diff --git a/test/name-test/run-test-systemserver.sh b/test/name-test/run-test-systemserver.sh
new file mode 100755
index 00000000..fd82326c
--- /dev/null
+++ b/test/name-test/run-test-systemserver.sh
@@ -0,0 +1,41 @@
+#! /bin/sh
+die()
+{
+ if ! test -z "$DBUS_SESSION_BUS_PID" ; then
+ echo "killing message bus "$DBUS_SESSION_BUS_PID >&2
+ kill -9 $DBUS_SESSION_BUS_PID
+ fi
+ echo $SCRIPTNAME: $* >&2
+
+ exit 1
+}
+
+SCRIPTNAME=$0
+MODE=$1
+
+## so the tests can complain if you fail to use the script to launch them
+DBUS_TEST_NAME_RUN_TEST_SCRIPT=1
+export DBUS_TEST_NAME_RUN_TEST_SCRIPT
+
+SOURCE_CONFIG_FILE=$DBUS_TOP_SRCDIR/test/name-test/tmp-session-like-system.conf
+export SOURCE_CONFIG_FILE
+# Rerun ourselves with tmp session bus if we're not already
+if test -z "$DBUS_TEST_NAME_IN_SYS_RUN_TEST"; then
+ DBUS_TEST_NAME_IN_SYS_RUN_TEST=1
+ export DBUS_TEST_NAME_IN_SYS_RUN_TEST
+ exec $DBUS_TOP_SRCDIR/tools/run-with-tmp-session-bus.sh $SCRIPTNAME $MODE
+fi
+
+if test -n "$DBUS_TEST_MONITOR"; then
+ dbus-monitor --session &
+fi
+
+echo "running test-expected-echo-fail"
+${DBUS_TOP_BUILDDIR}/libtool --mode=execute $DEBUG $DBUS_TOP_BUILDDIR/tools/dbus-send --print-reply --dest=org.freedesktop.DBus.TestSuiteEchoService /org/freedesktop/TestSuite org.freedesktop.TestSuite.Echo string:hi >echo-error-output.tmp 2>&1
+if ! grep -q 'DBus.Error' echo-error-output.tmp; then
+ echo "Didn't get expected failure; output was:"
+ echo "====="
+ cat echo-error-output.tmp
+ echo "====="
+ exit 1
+fi